<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from dataprocessor/xml/schema/CRM/Dataprocessor/DataProcessorFilterHandler.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:0bec9ca27a1543c58fa6e52cdd3ff528)
 */
use CRM_Dataprocessor_ExtensionUtil as E;

/**
 * Database access object for the DataProcessorFilter entity.
 */
class CRM_Dataprocessor_DAO_DataProcessorFilter extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_data_processor_filter';

  /**
   * Field to show when displaying a record.
   *
   * @var string
   */
  public static $_labelField = 'title';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = FALSE;

  /**
   * Unique DataProcessorFilter ID
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * FK to Data Processor
   *
   * @var int|string
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $data_processor_id;

  /**
   * @var int|string
   *   (SQL type: int)
   *   Note that values will be retrieved from the database as a string.
   */
  public $weight;

  /**
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $name;

  /**
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $title;

  /**
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $type;

  /**
   * @var bool|string
   *   (SQL type: tinyint)
   *   Note that values will be retrieved from the database as a string.
   */
  public $is_required;

  /**
   * @var bool|string
   *   (SQL type: tinyint)
   *   Note that values will be retrieved from the database as a string.
   */
  public $is_exposed;

  /**
   * @var string
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $configuration;

  /**
   * @var string
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $filter_value;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $collection_id;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_data_processor_filter';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('Data Processor Filters') : E::ts('Data Processor Filter');
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('ID'),
          'description' => E::ts('Unique DataProcessorFilter ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.id',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'data_processor_id' => [
          'name' => 'data_processor_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Data Processor ID'),
          'description' => E::ts('FK to Data Processor'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.data_processor_id',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'FKClassName' => 'CRM_Dataprocessor_DAO_DataProcessor',
          'add' => NULL,
        ],
        'weight' => [
          'name' => 'weight',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Weight'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.weight',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'add' => NULL,
        ],
        'name' => [
          'name' => 'name',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Name'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.name',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'add' => NULL,
        ],
        'title' => [
          'name' => 'title',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Title'),
          'required' => TRUE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.title',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'add' => NULL,
        ],
        'type' => [
          'name' => 'type',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Type'),
          'required' => TRUE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.type',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'add' => NULL,
        ],
        'is_required' => [
          'name' => 'is_required',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => E::ts('Is required'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.is_required',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'add' => NULL,
        ],
        'is_exposed' => [
          'name' => 'is_exposed',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => E::ts('Is exposed'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.is_exposed',
          'default' => '1',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'add' => NULL,
        ],
        'configuration' => [
          'name' => 'configuration',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Configuration'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.configuration',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'serialize' => self::SERIALIZE_JSON,
          'add' => NULL,
        ],
        'filter_value' => [
          'name' => 'filter_value',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Default Filter Value'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.filter_value',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'serialize' => self::SERIALIZE_JSON,
          'add' => NULL,
        ],
        'collection_id' => [
          'name' => 'collection_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Filter Collection Id'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter.collection_id',
          'table_name' => 'civicrm_data_processor_filter',
          'entity' => 'DataProcessorFilter',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilter',
          'localizable' => 0,
          'FKClassName' => 'CRM_Dataprocessor_DAO_DataProcessorFilterCollection',
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'data_processor_filter', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'data_processor_filter', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
