<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from dataprocessor/xml/schema/CRM/Dataprocessor/DataProcessorFilterCollection.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:3c4c74e46acd9b9dffd549d17293d118)
 */
use CRM_Dataprocessor_ExtensionUtil as E;

/**
 * Database access object for the DataProcessorFilterCollection entity.
 */
class CRM_Dataprocessor_DAO_DataProcessorFilterCollection extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_data_processor_filter_collection';

  /**
   * Field to show when displaying a record.
   *
   * @var string
   */
  public static $_labelField = 'title';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = FALSE;

  /**
   * Unique DataProcessorFilterCollection ID
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * FK to Data Processor
   *
   * @var int|string
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $data_processor_id;

  /**
   * @var int|string
   *   (SQL type: int)
   *   Note that values will be retrieved from the database as a string.
   */
  public $weight;

  /**
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $name;

  /**
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $title;

  /**
   * @var string
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $description;

  /**
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $condition;

  /**
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $link_condition;

  /**
   * @var bool|string
   *   (SQL type: tinyint)
   *   Note that values will be retrieved from the database as a string.
   */
  public $show_collapsed;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_data_processor_filter_collection';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('Data Processor Filter Collections') : E::ts('Data Processor Filter Collection');
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('ID'),
          'description' => E::ts('Unique DataProcessorFilterCollection ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter_collection.id',
          'table_name' => 'civicrm_data_processor_filter_collection',
          'entity' => 'DataProcessorFilterCollection',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilterCollection',
          'localizable' => 0,
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'data_processor_id' => [
          'name' => 'data_processor_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Data Processor ID'),
          'description' => E::ts('FK to Data Processor'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter_collection.data_processor_id',
          'table_name' => 'civicrm_data_processor_filter_collection',
          'entity' => 'DataProcessorFilterCollection',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilterCollection',
          'localizable' => 0,
          'FKClassName' => 'CRM_Dataprocessor_DAO_DataProcessor',
          'add' => NULL,
        ],
        'weight' => [
          'name' => 'weight',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Weight'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter_collection.weight',
          'table_name' => 'civicrm_data_processor_filter_collection',
          'entity' => 'DataProcessorFilterCollection',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilterCollection',
          'localizable' => 0,
          'add' => NULL,
        ],
        'name' => [
          'name' => 'name',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Name'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter_collection.name',
          'table_name' => 'civicrm_data_processor_filter_collection',
          'entity' => 'DataProcessorFilterCollection',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilterCollection',
          'localizable' => 0,
          'add' => NULL,
        ],
        'title' => [
          'name' => 'title',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Title'),
          'required' => TRUE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter_collection.title',
          'table_name' => 'civicrm_data_processor_filter_collection',
          'entity' => 'DataProcessorFilterCollection',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilterCollection',
          'localizable' => 0,
          'add' => NULL,
        ],
        'description' => [
          'name' => 'description',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Description'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter_collection.description',
          'table_name' => 'civicrm_data_processor_filter_collection',
          'entity' => 'DataProcessorFilterCollection',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilterCollection',
          'localizable' => 0,
          'add' => NULL,
        ],
        'condition' => [
          'name' => 'condition',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Condition'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter_collection.condition',
          'default' => 'AND',
          'table_name' => 'civicrm_data_processor_filter_collection',
          'entity' => 'DataProcessorFilterCollection',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilterCollection',
          'localizable' => 0,
          'add' => NULL,
        ],
        'link_condition' => [
          'name' => 'link_condition',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Condition for linking this collection to the previous collection'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter_collection.link_condition',
          'default' => 'AND',
          'table_name' => 'civicrm_data_processor_filter_collection',
          'entity' => 'DataProcessorFilterCollection',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilterCollection',
          'localizable' => 0,
          'add' => NULL,
        ],
        'show_collapsed' => [
          'name' => 'show_collapsed',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => E::ts('Show Collapsed'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_data_processor_filter_collection.show_collapsed',
          'table_name' => 'civicrm_data_processor_filter_collection',
          'entity' => 'DataProcessorFilterCollection',
          'bao' => 'CRM_Dataprocessor_DAO_DataProcessorFilterCollection',
          'localizable' => 0,
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'data_processor_filter_collection', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'data_processor_filter_collection', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
